"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpCode = void 0;
var OpCode;
(function (OpCode) {
    OpCode[OpCode["NOOP"] = 0] = "NOOP";
    OpCode[OpCode["HALT"] = 1] = "HALT";
    OpCode[OpCode["CALL"] = 2] = "CALL";
    OpCode[OpCode["CALL_INTERNAL"] = 3] = "CALL_INTERNAL";
    OpCode[OpCode["CALL_WITH_CONTEXT"] = 4] = "CALL_WITH_CONTEXT";
    OpCode[OpCode["CONSTRUCT_MAP"] = 5] = "CONSTRUCT_MAP";
    OpCode[OpCode["CONSTRUCT_LIST"] = 6] = "CONSTRUCT_LIST";
    OpCode[OpCode["GET_VARIABLE"] = 7] = "GET_VARIABLE";
    OpCode[OpCode["GET_PROPERTY"] = 8] = "GET_PROPERTY";
    OpCode[OpCode["GET_ENVAR"] = 9] = "GET_ENVAR";
    OpCode[OpCode["GET_SELF"] = 10] = "GET_SELF";
    OpCode[OpCode["GET_OUTER"] = 11] = "GET_OUTER";
    OpCode[OpCode["GET_GLOBALS"] = 12] = "GET_GLOBALS";
    OpCode[OpCode["GET_LOCALS"] = 13] = "GET_LOCALS";
    OpCode[OpCode["GET_SUPER"] = 14] = "GET_SUPER";
    OpCode[OpCode["GET_SUPER_PROPERTY"] = 15] = "GET_SUPER_PROPERTY";
    OpCode[OpCode["CALL_SUPER_PROPERTY"] = 16] = "CALL_SUPER_PROPERTY";
    OpCode[OpCode["FALSIFY"] = 17] = "FALSIFY";
    OpCode[OpCode["NEGATE"] = 18] = "NEGATE";
    OpCode[OpCode["NEW"] = 19] = "NEW";
    OpCode[OpCode["SLICE"] = 20] = "SLICE";
    OpCode[OpCode["ASSIGN"] = 21] = "ASSIGN";
    OpCode[OpCode["PUSH"] = 22] = "PUSH";
    OpCode[OpCode["POP"] = 23] = "POP";
    OpCode[OpCode["ISA"] = 24] = "ISA";
    OpCode[OpCode["ADD"] = 25] = "ADD";
    OpCode[OpCode["SUB"] = 26] = "SUB";
    OpCode[OpCode["MUL"] = 27] = "MUL";
    OpCode[OpCode["DIV"] = 28] = "DIV";
    OpCode[OpCode["MOD"] = 29] = "MOD";
    OpCode[OpCode["POW"] = 30] = "POW";
    OpCode[OpCode["EQUAL"] = 31] = "EQUAL";
    OpCode[OpCode["NOT_EQUAL"] = 32] = "NOT_EQUAL";
    OpCode[OpCode["LESS_THAN"] = 33] = "LESS_THAN";
    OpCode[OpCode["LESS_THAN_OR_EQUAL"] = 34] = "LESS_THAN_OR_EQUAL";
    OpCode[OpCode["GREATER_THAN"] = 35] = "GREATER_THAN";
    OpCode[OpCode["GREATER_THAN_OR_EQUAL"] = 36] = "GREATER_THAN_OR_EQUAL";
    OpCode[OpCode["AND"] = 37] = "AND";
    OpCode[OpCode["OR"] = 38] = "OR";
    OpCode[OpCode["RETURN"] = 39] = "RETURN";
    OpCode[OpCode["FUNCTION_DEFINITION"] = 40] = "FUNCTION_DEFINITION";
    OpCode[OpCode["GOTO_A"] = 41] = "GOTO_A";
    OpCode[OpCode["GOTO_A_IF_FALSE"] = 42] = "GOTO_A_IF_FALSE";
    OpCode[OpCode["GOTO_A_IF_FALSE_AND_PUSH"] = 43] = "GOTO_A_IF_FALSE_AND_PUSH";
    OpCode[OpCode["GOTO_A_IF_TRUE_AND_PUSH"] = 44] = "GOTO_A_IF_TRUE_AND_PUSH";
    OpCode[OpCode["PUSH_ITERATOR"] = 45] = "PUSH_ITERATOR";
    OpCode[OpCode["POP_ITERATOR"] = 46] = "POP_ITERATOR";
    OpCode[OpCode["NEXT"] = 47] = "NEXT";
    OpCode[OpCode["BITWISE_OR"] = 48] = "BITWISE_OR";
    OpCode[OpCode["BITWISE_AND"] = 49] = "BITWISE_AND";
    OpCode[OpCode["BITWISE_LEFT_SHIFT"] = 50] = "BITWISE_LEFT_SHIFT";
    OpCode[OpCode["BITWISE_RIGHT_SHIFT"] = 51] = "BITWISE_RIGHT_SHIFT";
    OpCode[OpCode["BITWISE_UNSIGNED_RIGHT_SHIFT"] = 52] = "BITWISE_UNSIGNED_RIGHT_SHIFT";
    OpCode[OpCode["BREAKPOINT"] = 53] = "BREAKPOINT";
    OpCode[OpCode["BREAKPOINT_ENABLE"] = 54] = "BREAKPOINT_ENABLE";
    OpCode[OpCode["IMPORT"] = 55] = "IMPORT";
})(OpCode = exports.OpCode || (exports.OpCode = {}));
