"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HandlerContainer = void 0;
const error_1 = require("./handler/error");
const output_1 = require("./handler/output");
const resource_1 = require("./handler/resource");
class HandlerContainer {
    constructor(options = {}) {
        var _a, _b, _c;
        this.resourceHandler =
            (_a = options === null || options === void 0 ? void 0 : options.resourceHandler) !== null && _a !== void 0 ? _a : new resource_1.DefaultResourceHandler();
        this.outputHandler = (_b = options === null || options === void 0 ? void 0 : options.outputHandler) !== null && _b !== void 0 ? _b : new output_1.DefaultOutputHandler();
        this.errorHandler = (_c = options === null || options === void 0 ? void 0 : options.errorHandler) !== null && _c !== void 0 ? _c : new error_1.DefaultErrorHandler();
    }
}
exports.HandlerContainer = HandlerContainer;
