"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultOutputHandler = exports.OutputHandler = void 0;
class OutputHandler {
}
exports.OutputHandler = OutputHandler;
class DefaultOutputHandler extends OutputHandler {
    print(_vm, message, { appendNewLine = true } = {}) {
        if (appendNewLine) {
            process.stdout.write(message + '\n');
        }
        else {
            process.stdout.write(message);
        }
    }
    update(_vm, message, { appendNewLine = false, replace = false } = {}) {
        if (replace) {
            process.stdout.write('\x1b[2K\r' + message + (appendNewLine ? '\n' : ''));
        }
        else {
            process.stdout.write(message + (appendNewLine ? '\n' : ''));
        }
    }
    progress(_vm, timeout) {
        return new Promise((resolve, _reject) => {
            setTimeout(resolve, timeout);
        });
    }
    waitForInput(_vm, _isPassword, _message) {
        return Promise.resolve('test');
    }
    waitForKeyPress(_vm, _message) {
        return Promise.resolve({
            keyCode: 13,
            code: 'Enter'
        });
    }
    clear(_vm) {
        console.clear();
    }
}
exports.DefaultOutputHandler = DefaultOutputHandler;
