"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultResourceHandler = exports.ResourceHandler = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
class ResourceHandler {
}
exports.ResourceHandler = ResourceHandler;
class DefaultResourceHandler extends ResourceHandler {
    getTargetRelativeTo(source, target) {
        const base = path_1.default.resolve(source, '..');
        const result = path_1.default.resolve(base, target);
        return Promise.resolve(fs_1.default.existsSync(result) ? result : result + '.src');
    }
    has(target) {
        return Promise.resolve(fs_1.default.existsSync(target));
    }
    get(target) {
        return Promise.resolve(fs_1.default.readFileSync(target, 'utf8'));
    }
    resolve(target) {
        return Promise.resolve(path_1.default.resolve(target));
    }
}
exports.DefaultResourceHandler = DefaultResourceHandler;
