"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultFalse = exports.DefaultTrue = exports.CustomBoolean = void 0;
const number_1 = require("./number");
class CustomBoolean extends number_1.CustomNumber {
    constructor(value) {
        super(+value);
    }
    getCustomType() {
        return 'number';
    }
    toJSON() {
        return this.toNumber().toString();
    }
    toString() {
        return this.value.toString();
    }
    fork() {
        return new CustomBoolean(!!this.value);
    }
    toNumber() {
        return this.value ? 1.0 : 0.0;
    }
    toInt() {
        return this.value ? 1 : 0;
    }
    toTruthy() {
        return !!this.value;
    }
}
exports.CustomBoolean = CustomBoolean;
exports.DefaultTrue = new CustomBoolean(true);
exports.DefaultFalse = new CustomBoolean(false);
