import { ContextTypeIntrinsics } from '../context/types';
import { ObjectValue } from '../utils/object-value';
import { CustomValue } from './base';
import { CustomObject, CustomValueWithIntrinsicsResult } from './with-intrinsics';
export declare class CustomListIterator implements Iterator<CustomValue> {
    value: Array<CustomValue>;
    index: number;
    constructor(value: Array<CustomValue>);
    next(): IteratorResult<CustomValue>;
}
export declare class CustomList extends CustomObject {
    static readonly intrinsics: ObjectValue;
    static getItemIndex(item: CustomList, index: number): number;
    readonly id: string;
    readonly value: Array<CustomValue>;
    constructor(value?: Array<CustomValue>);
    getCustomType(): string;
    toJSON(depth?: number): string;
    toString(depth?: number): string;
    fork(): CustomList;
    toNumber(): number;
    toInt(): number;
    toTruthy(): boolean;
    getSize(): number;
    instanceOf(v: CustomValue, typeIntrinsics: ContextTypeIntrinsics): boolean;
    slice(a: CustomValue, b: CustomValue): CustomList;
    extend(list: CustomList | Array<CustomValue>): CustomList;
    [Symbol.iterator](): CustomListIterator;
    getItemIndex(index: number): number;
    has(current: CustomValue): boolean;
    set(current: CustomValue, newValue: CustomValue): void;
    get(current: CustomValue, typeIntrinsics: ContextTypeIntrinsics): CustomValue;
    getWithOrigin(current: CustomValue, typeIntrinsics: ContextTypeIntrinsics): CustomValueWithIntrinsicsResult;
    hash(recursionDepth?: number): number;
}
