import { ContextTypeIntrinsics } from '../context/types';
import { ObjectValue } from '../utils/object-value';
import { CustomValue } from './base';
import { CustomObject, CustomValueWithIntrinsicsResult } from './with-intrinsics';
export declare const CUSTOM_MAP_MAX_DEPTH = 2;
export declare const CUSTOM_MAP_MAX_DEPTH_VALUE = "{...}";
export declare class CustomMapIterator implements Iterator<CustomValue> {
    value: ObjectValue;
    index: number;
    constructor(value: ObjectValue);
    next(): IteratorResult<CustomMap>;
}
export declare class CustomMap extends CustomObject {
    static readonly intrinsics: ObjectValue;
    readonly id: string;
    value: ObjectValue;
    isInstance: boolean;
    static createWithInitialValue(value: ObjectValue): CustomMap;
    constructor(value?: ObjectValue);
    getCustomType(): string;
    toJSON(depth?: number): string;
    toString(depth?: number): string;
    fork(): CustomMap;
    toNumber(): number;
    toInt(): number;
    toTruthy(): boolean;
    getSize(): number;
    instanceOf(v: CustomValue, typeIntrinsics: ContextTypeIntrinsics): boolean;
    [Symbol.iterator](): CustomMapIterator;
    extend(map: CustomMap | ObjectValue): CustomMap;
    has(current: CustomValue): boolean;
    set(current: CustomValue, newValue: CustomValue): void;
    get(current: CustomValue, typeIntrinsics: ContextTypeIntrinsics): CustomValue;
    getWithOrigin(current: CustomValue, typeIntrinsics: ContextTypeIntrinsics): CustomValueWithIntrinsicsResult;
    createInstance(): CustomMap;
    getIsa(): CustomMap | null;
    hash(recursionDepth?: number): number;
}
