"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Void = exports.CustomNil = void 0;
const base_1 = require("./base");
class CustomNil extends base_1.CustomValue {
    constructor() {
        super(...arguments);
        this.id = 'null';
        this.value = null;
    }
    getCustomType() {
        return 'null';
    }
    toJSON() {
        return this.toString();
    }
    toString() {
        return 'null';
    }
    fork() {
        return new CustomNil();
    }
    toNumber() {
        return undefined;
    }
    toInt() {
        return undefined;
    }
    toTruthy() {
        return false;
    }
    instanceOf(v) {
        return v instanceof CustomNil;
    }
    hash() {
        return -1;
    }
}
exports.CustomNil = CustomNil;
exports.Void = new CustomNil();
