import { ContextTypeIntrinsics } from '../context/types';
import { ObjectValue } from '../utils/object-value';
import { CustomValue } from './base';
import { CustomValueWithIntrinsics, CustomValueWithIntrinsicsResult } from './with-intrinsics';
export declare class CustomNumberIterator implements Iterator<CustomValue> {
    index: number;
    next(): IteratorResult<CustomValue>;
}
export declare class CustomNumber extends CustomValueWithIntrinsics {
    static readonly intrinsics: ObjectValue;
    readonly id: string;
    readonly value: number;
    constructor(value: number);
    getCustomType(): string;
    toJSON(): string;
    toString(): string;
    fork(): CustomNumber;
    toInt(): number;
    toNumber(): number;
    toTruthy(): boolean;
    instanceOf(v: CustomValue, typeIntrinsics: ContextTypeIntrinsics): boolean;
    [Symbol.iterator](): CustomNumberIterator;
    has(_path: CustomValue): boolean;
    set(_path: CustomValue, _newValue: CustomValue): void;
    get(current: CustomValue, typeIntrinsics: ContextTypeIntrinsics): CustomValue;
    getWithOrigin(current: CustomValue, typeIntrinsics: ContextTypeIntrinsics): CustomValueWithIntrinsicsResult;
    hash(): number;
}
export declare const NegativeOne: CustomNumber;
export declare const PositiveOne: CustomNumber;
export declare const Zero: CustomNumber;
