import { ContextTypeIntrinsics } from '../context/types';
import { ObjectValue } from '../utils/object-value';
import { CustomValue } from './base';
import { CustomValueWithIntrinsics, CustomValueWithIntrinsicsResult } from './with-intrinsics';
export declare class CustomStringIterator implements Iterator<CustomValue> {
    value: string;
    index: number;
    constructor(value: string);
    next(): IteratorResult<CustomValue>;
}
export declare class CustomString extends CustomValueWithIntrinsics {
    static readonly intrinsics: ObjectValue;
    static getCharIndex(item: CustomString, index: number): number;
    readonly id: string;
    readonly value: string;
    constructor(value: string);
    getCustomType(): string;
    toJSON(): string;
    toString(): string;
    fork(): CustomString;
    isNumber(): boolean;
    parseFloat(): number;
    parseInt(): number;
    toNumber(): number;
    toInt(): number;
    toTruthy(): boolean;
    instanceOf(v: CustomValue, typeIntrinsics: ContextTypeIntrinsics): boolean;
    slice(a: CustomValue, b: CustomValue): CustomString;
    [Symbol.iterator](): CustomStringIterator;
    getCharIndex(index: number): number;
    has(current: CustomValue): boolean;
    set(_path: CustomValue, _newValue: CustomValue): void;
    get(current: CustomValue, typeIntrinsics: ContextTypeIntrinsics): CustomValue;
    getWithOrigin(current: CustomValue, typeIntrinsics: ContextTypeIntrinsics): CustomValueWithIntrinsicsResult;
    hash(): number;
}
export declare const Self: CustomString;
export declare const Isa: CustomString;
export declare const Super: CustomString;
export declare const Globals: CustomString;
export declare const Locals: CustomString;
export declare const Outer: CustomString;
