import { ContextTypeIntrinsics } from '../context/types';
import { ObjectValue } from '../utils/object-value';
import { CustomValue } from './base';
import { CustomFunction } from './function';
export type CustomValueWithIntrinsicsResult = {
    value: CustomValue;
    origin: CustomValueWithIntrinsics;
};
export declare abstract class CustomValueWithIntrinsics extends CustomValue {
    abstract has(path: CustomValue): boolean;
    abstract set(path: CustomValue, value: CustomValue): void;
    abstract get(path: CustomValue, typeIntrinsics: ContextTypeIntrinsics): CustomValue;
    abstract getWithOrigin(path: CustomValue, typeIntrinsics: ContextTypeIntrinsics): CustomValueWithIntrinsicsResult;
    abstract [Symbol.iterator](): Iterator<CustomValue> & {
        index: number;
    };
    static readonly intrinsics: ObjectValue;
    static getIntrinsics(): ObjectValue;
    static addIntrinsic(key: CustomValue, fn: CustomFunction): void;
    static clearIntrinsics(): void;
    getIntrinsics(): ObjectValue;
}
export declare abstract class CustomObject extends CustomValueWithIntrinsics {
    abstract getSize(): number;
}
