import { ASTRange } from 'miniscript-core';
import { Instruction } from '../byte-compiler/instruction';
interface RuntimeVM {
    getFrame(): {
        getCurrentInstruction: () => Instruction;
    };
    getStacktrace?: () => Instruction[];
    target: string;
}
export declare class RuntimeError extends Error {
    target: string;
    stackTrace: Instruction[];
    source?: Error;
    constructor(message: string, vm?: RuntimeVM, source?: Error);
    private createTrace;
}
interface PrepareContext {
    range: ASTRange;
    target: string;
}
export declare class PrepareError extends Error {
    range: ASTRange;
    target: string;
    source?: Error;
    constructor(message: string, context: PrepareContext, source?: Error);
}
export {};
