"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrepareError = exports.RuntimeError = void 0;
class RuntimeError extends Error {
    constructor(message, vm, source) {
        var _a;
        super(message);
        this.target = vm === null || vm === void 0 ? void 0 : vm.getFrame().getCurrentInstruction().source.path;
        this.stackTrace = (_a = vm === null || vm === void 0 ? void 0 : vm.getStacktrace()) !== null && _a !== void 0 ? _a : [];
        this.stack = this.createTrace();
        this.source = source;
    }
    createTrace() {
        return this.stackTrace
            .map((op) => {
            return `at ${op.source.path}:${op.source.start.line}:${op.source.start.character}`;
        })
            .join('\n');
    }
}
exports.RuntimeError = RuntimeError;
class PrepareError extends Error {
    constructor(message, context, source) {
        super(message);
        this.range = context.range;
        this.target = context.target;
        this.source = source;
    }
}
exports.PrepareError = PrepareError;
